<?php

namespace App;

use App\Module;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Illuminate\Database\Eloquent\SoftDeletes;


class User extends Authenticatable
{
    use Notifiable;
    use SoftDeletes;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = array('name','auction' ,'email', 'password','last_seen' , 'phone', 'photo','country_id','hanqr','role','gender','city_id','date_of_birth','code','zip_id','latlng','address','wallet','facebook','twitter','instagram','snapchat');

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    /**
     * Get the modules of this user
     * @return BelongsToMany
     */
    public function modules()
    {
        return $this->belongsToMany(Module::class,'user_modules');
    }
    
    public function country()
    {
        return $this->belongsTo(Country::class,'country_id');
    }

    /**
     * Check if the user can access a module
     * @param string, module name
     * @return bool
     */
    public function hasModule($module)
    {
        if($this->modules->contains('path',$module))
        {
            return true;
        }
        return false;
    }

    /**
     * Check if the user can access a module
     * @param string, module name
     * @return bool
     */
    public function canAccess($module)
    {
        // dd($this->role);
        if ( 'admin' == $this->role ) {
            return true;
        }else {
            return $this->hasModule($module);
        }
        return false;
    }
}
